package com.zoinla.flir_plugin

import android.util.Log
import androidx.exifinterface.media.ExifInterface
import java.util.*

class ExifDataCopier {
    fun copyExif(filePathOri: String, filePathDest: String) {
        try {
            val oldExif = ExifInterface(filePathOri)
            val newExif = ExifInterface(filePathDest)
            val attributes = Arrays.asList(
                    "FNumber",
                    "ExposureTime",
                    "ISOSpeedRatings",
                    "GPSAltitude",
                    "GPSAltitudeRef",
                    "FocalLength",
                    "GPSDateStamp",
                    "WhiteBalance",
                    "GPSProcessingMethod",
                    "GPSTimeStamp",
                    "DateTime",
                    "Flash",
                    "GPSLatitude",
                    "GPSLatitudeRef",
                    "GPSLongitude",
                    "GPSLongitudeRef",
                    "Make",
                    "Model",
                    "Orientation")
            for (attribute in attributes) {
                setIfNotNull(oldExif, newExif, attribute)
            }
            newExif.saveAttributes()
        } catch (ex: Exception) {
            Log.e("ExifDataCopier", "Error preserving Exif data on selected image: $ex")
        }
    }

    private fun setIfNotNull(oldExif: ExifInterface, newExif: ExifInterface, property: String) {
        if (oldExif.getAttribute(property) != null) {
            newExif.setAttribute(property, oldExif.getAttribute(property))
        }
    }
}